# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.mondate import tMondate

class dMondateInsert:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tMondate()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec_deft(self,
                  id: str,
                  descr: str,
                  value: datetime.date,
                  stamp_by: str,
                  stamp_tm: datetime.datetime) -> "dMondateInsert":
        """
        Execute the query by setting all the inputs.

        :param id: str
        :param descr: str
        :param value: datetime.date
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.id = id
        self.irec.descr = descr
        self.irec.value = value
        self.irec.stamp_by = stamp_by
        self.irec.stamp_tm = stamp_tm

        return self.exec()

    def exec(self, irec: tMondate = None) -> "dMondateInsert":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("MondateInsert", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""insert into monitor.Mondate (
  id,
  descr,
  value,
  stamp_by,
  stamp_tm
) values (
  :id,
  :descr,
  :value,
  :stamp_by,
  :stamp_tm
)""")

        self.irec.stamp_tm = self._dbcon.get_timestamp()

        self._dbstmnt.bind_in("id", self.irec.id, str, 16)
        self._dbstmnt.bind_in("descr", self.irec.descr, str)
        self._dbstmnt.bind_in("value", self.irec.value, datetime.date)
        self._dbstmnt.bind_in("stamp_by", self.irec.stamp_by, str, 128)
        self._dbstmnt.bind_in("stamp_tm", self.irec.stamp_tm, datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

