# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#  Target Database = postgresql
#
import asyncio
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job import tJob
from bs_monitor.db.tables.job_key import tJobKey

from .job_select_one import dJobSelectOne
from .job_update import dJobUpdate
from .job_insert import dJobInsert
from .job_delete_one import dJobDeleteOne

class dJob:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self.rec    = tJob()
        self._dbcon = dbcon

    def __enter__(self):
        """
        DAO enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        DAO exit.
        """
        pass

    async def try_select_one(self) -> bool:
        """
        Attempt to select the record.

        :return: True if the record was found.
        """
        _key = tJobKey()

        self.rec._write_key(_key)

        return await self.try_select_one_by_key(_key)

    async def try_select_one_with(self, _rec: tJob) -> bool:
        """
        Attempt to select the record using a table rec.

        :param _rec: The table rec to select with and into.
        :return: True if the row as selectd.
        """
        _key = tJobKey()
        _rec._write_key(_key)

        if not await self.try_select_one_by_key(_key):
            return False

        _rec._copy_from(self.rec)

        return True

    async def try_select_one_deft(self,
                                  id: int) -> bool:
        """
        Attempt to select the record by it's primary key columns.

        :param id: int
        :return: True if the row as selectd.
        """
        _key = tJobKey()

        _key.id = id

        return await self.try_select_one_by_key(_key)

    async def try_select_one_by_key(self, _key: tJobKey) -> bool:
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :returns: True if row was selected.
        """
        with dJobSelectOne(self._dbcon) as _qry:
            await _qry.exec(_key)
            if not await _qry.fetch():
                return False

            self.rec = _qry.orec

        return True

    async def select_one(self) -> "dJob":
        """
        Selects the record, raises and error if it does not exist.

        :return: Self for convenience.
        """
        if not await self.try_select_one():
            raise mettle.lib.xMettle("SelectOne failed to return a record (dJob)")

        return self

    async def select_one_with(self, _rec: tJob) -> "dJob":
        """
        Attempt to select the record with the table record.

        :param _rec: Table record.
        :returns: Self for convenience.
        """
        if not await self.try_select_one_with(_rec):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dJob)")

        return self

    async def select_one_deft(self,
                              id: int) -> "dJob":
        """
        Selects the record by its primary key columns, raises and error if it does not exist.

        :param id: int
        """
        _key = tJobKey()

        _key.id = id

        if not await self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dJob)")

        return self

    async def select_one_by_key(self, _key: tJobKey) -> "dJob":
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :return: Self for convenience.
        """
        if not await self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dJob)")

        return self

    async def update_deft(self,
                          id: int,
                          name: str,
                          group_id: str,
                          program_path: str,
                          program_args: str,
                          priority: int,
                          stamp_by: str):
        """
        Update the record by setting all column values.

        :param id: int
        :param name: str
        :param group_id: str
        :param program_path: str
        :param program_args: str
        :param priority: int
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        """
        self.rec.id = id
        self.rec.name = name
        self.rec.group_id = group_id
        self.rec.program_path = program_path
        self.rec.program_args = program_args
        self.rec.priority = priority
        self.rec.stamp_by = stamp_by

        await self.update()

    async def update(self, irec: tJob = None):
        """
        Update the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to update the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dJobUpdate(self._dbcon) as _qry:
            await _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    async def insert_deft(self,
                          name: str,
                          group_id: str,
                          program_path: str,
                          program_args: str,
                          priority: int,
                          stamp_by: str):
        """
        Insert the record setting all column values.

        :param id: int
        :param name: str
        :param group_id: str
        :param program_path: str
        :param program_args: str
        :param priority: int
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        """
        self.rec.name = name
        self.rec.group_id = group_id
        self.rec.program_path = program_path
        self.rec.program_args = program_args
        self.rec.priority = priority
        self.rec.stamp_by = stamp_by

        await self.insert()

    async def insert(self, irec: tJob = None):
        """
        Insert the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to insert into the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dJobInsert(self._dbcon) as _qry:
            await _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    async def delete_one_deft(self,
                              id: int):
        """
        Delete one record by it's primary key columns.

        :param id: int
        """
        _key = tJobKey()

        _key.id = id

        await self.delete_one(_key)

    async def delete_one(self, irec: tJobKey = None):
        """
        Delete the record by its primary key or irec if it is not None.

        :param irec: If not None use this record to delete record.
        """
        _key = tJobKey()

        if irec:
            _key._copy_from(irec)
        else:
            self.rec._write_key(_key)

        with dJobDeleteOne(self._dbcon) as _qry:
            await _qry.exec(_key)

