# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from .batch_inst_key import tBatchInstKey

class tBatchInst(mettle.io.ISerializable, mettle.db.IPrimaryKey):

    def __init__(self,
                 id: int = 0,
                 parent_id: int = 0,
                 batch_id: int = 0,
                 status: str = '',
                 run_date: datetime.datetime = None,
                 start_date: datetime.datetime = None,
                 end_date: datetime.datetime = None):
        """
        Constructor.

        :param id: int
        :param parent_id: int
        :param batch_id: int
        :param status: str
        :param run_date: datetime.datetime
        :param start_date: datetime.datetime
        :param end_date: datetime.datetime
        """
        self.id = id
        self.parent_id = parent_id
        self.batch_id = batch_id
        self.status = status
        self.run_date = run_date
        self.start_date = start_date
        self.end_date = end_date

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.id = 0
        self.parent_id = 0
        self.batch_id = 0
        self.status = ''
        self.run_date = None
        self.start_date = None
        self.end_date = None

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'tBatchInst'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_int64("id", self.id)
        _w.write_int64("parent_id", self.parent_id)
        _w.write_int64("batch_id", self.batch_id)
        _w.write_char("status", self.status)
        _w.write_datetime("run_date", self.run_date)
        _w.write_datetime("start_date", self.start_date)
        _w.write_datetime("end_date", self.end_date)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.id = _r.read_int64("id")
        self.parent_id = _r.read_int64("parent_id")
        self.batch_id = _r.read_int64("batch_id")
        self.status = _r.read_char("status")
        self.run_date = _r.read_datetime("run_date")
        self.start_date = _r.read_datetime("start_date")
        self.end_date = _r.read_datetime("end_date")
        _r.read_end(_oname)

    def _copy_from(self, rec: "tBatchInst"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.id = rec.id
        self.parent_id = rec.parent_id
        self.batch_id = rec.batch_id
        self.status = rec.status
        self.run_date = rec.run_date
        self.start_date = rec.start_date
        self.end_date = rec.end_date

    def _write_pk(self, _key: "tBatchInst"):
        """
        Write the primary key columns to the key object.

        :param _key:
        """
        self._write_key(_key)

    def _read_pk(self, _key: "tBatchInst"):
        """
        Read the primary key columns from the key object.

        :param _key:
        """
        self._read_key(_key)

    def _serialize_key(self, _w: mettle.io.IWriter):
        """
        Serialize the primary key to a stream.

        :param _w:
        """
        _key = tBatchInstKey()

        self._write_key(_key)
        _key._serialize(_w)

    def _deserialize_key(self, _r: mettle.io.IReader):
        """
        Deserialize the primary key from a stream.

        :param _r:
        """
        _key = tBatchInstKey()

        _key._deserialize(_r)
        self._read_key(_key)

    @staticmethod
    def _cache_davs(dvc=None, for_ins: bool = False, key_only: bool = False):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        :param for_ins: Davs for insert.
        :param key_only: Davs by key only, ie for delete/selectone.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        if not for_ins:
            dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
            dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        if key_only:
            return dvc

        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 1))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.In, ['P','B','C','N']))
        dvc.add_targ("run_date", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
        tBatchInst._cache_davs(dvc, for_ins, key_only)

    def _write_key(self, _key: tBatchInstKey):
        """
        Write primary key columns to _key.

        :param _key:
        """
        _key.id = self.id

    def _read_key(self, _key: tBatchInstKey):
        """
        Read the primary key columns from _key.

        :param _key:
        """
        self.id = _key.id

    class Status_Couplet(dict):
        key_pending = "P"
        key_busy = "B"
        key_completed = "C"
        key_not_applicable = "N"

        value_pending = "Pending"
        value_busy = "Busy"
        value_completed = "Completed"
        value_not_applicable = "Not Applicable"

        def __init__(self):
            self[self.key_pending] = self.value_pending
            self[self.key_busy] = self.value_busy
            self[self.key_completed] = self.value_completed
            self[self.key_not_applicable] = self.value_not_applicable

        @staticmethod
        def get_value(key):
            if key == tBatchInst.Status_Couplet.key_pending:
                return tBatchInst.Status_Couplet.value_pending

            if key == tBatchInst.Status_Couplet.key_busy:
                return tBatchInst.Status_Couplet.value_busy

            if key == tBatchInst.Status_Couplet.key_completed:
                return tBatchInst.Status_Couplet.value_completed

            if key == tBatchInst.Status_Couplet.key_not_applicable:
                return tBatchInst.Status_Couplet.value_not_applicable

            return ""

    @staticmethod
    def _pk_compare(x, y) -> int:
        """
        Compare function do primary key comparisons for list sorts and searches.

        :return: zero for x == y, negative for x < y, positive for x > y
        """
        return x.id - y.id

    def __lt__(self, other):
        return other and self._pk_compare(self, other) < 0

    def __gt__(self, other):
        return other and self._pk_compare(self, other) > 0

    def __eq__(self, other):
        return other and self._pk_compare(self, other) == 0

    def __le__(self, other):
        return other and self._pk_compare(self, other) <= 0

    def __ge__(self, other):
        return other and self._pk_compare(self, other) >= 0

    def __ne__(self, other):
        return other == None or self._pk_compare(self, other)

    def __repr__(self) -> str:
        return '<BatchInst [id:%r, parent_id:%r, batch_id:%r, status:%.32s, run_date:%s, start_date:%s, end_date:%s]>' % (
            self.id, self.parent_id, self.batch_id, self.status, self.run_date, self.start_date, self.end_date)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'tBatchInst.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = tBatchInst()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<tBatchInst.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
            return tBatchInst._cache_davs(dvc, for_ins, key_only)

